#NoTrayIcon
#include <GUIConstants.au3>

$BurpGuiVersion = "1.1"

Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode 

$x = GUICreate("Burp GUI (" & $BurpGuiVersion & ")", 400, 300, @DesktopWidth / 2 - 200, @DesktopHeight / 2 - 150, -1, $WS_EX_ACCEPTFILES)
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")

$Menu = GuiCtrlCreateMenu("Website")
$x = GuiCtrlCreateMenuItem("BURP Website", $Menu)
GuiCtrlSetOnEvent($x, "BurpWebsite")
$x = GuiCtrlCreateMenuItem("BURP-GUI Website", $Menu)
GuiCtrlSetOnEvent($x, "BurpGuiWebsite")

$Menu = GuiCtrlCreateMenu("&Help")
$x = GuiCtrlCreateMenuItem("About", $Menu)
GuiCtrlSetOnEvent($x, "AboutHelp")
$x = GuiCtrlCreateMenuItem("", $Menu)
$x = GuiCtrlCreateMenuItem("Passphrase / Key Help", $Menu)
GuiCtrlSetOnEvent($x, "PassHelp")
$x = GuiCtrlCreateMenuItem("Security Warnings", $Menu)
GuiCtrlSetOnEvent($x, "WarningsHelp")

$EncryptLast = 1
$Encrypt = GUICtrlCreateRadio("&Encrypt", 10, 10, 60)
GUICtrlSetState($Encrypt, $GUI_CHECKED)
GUICtrlSetOnEvent($Encrypt, "ToggleLabels")
$x = GUICtrlCreateRadio("&Decrypt", 10, 30, 60)
GUICtrlSetOnEvent($x, "ToggleLabels")

$x = GuiCtrlCreateLabel("&Passphrase or key:", 100, 10)
$Pass = GuiCtrlCreateInput("", 100, 30, 290, 20, BitOR($ES_PASSWORD, $ES_AUTOHSCROLL))
$PlainText = GuiCtrlCreateCheckbox("Show Passphrase / Key", 200, 7)
GuiCtrlSetOnEvent($PlainText, "ShowPlainText")

$TopLabel = GuiCtrlCreateLabel("Plain File:", 10, 82, 100)
$BottomLabel = GuiCtrlCreateLabel("Encrypted File:", 10, 112, 100)

$TopFile = GuiCtrlCreateInput("", 100, 80, 270)
GuiCtrlSetState($TopFile, $GUI_ACCEPTFILES)
$x = GuiCtrlCreateButton("...", 370, 80, 20, 20)
GuiCtrlSetOnEvent($x, "TopPickFile")

$BottomFile = GuiCtrlCreateInput("", 100, 110, 270)
$x = GuiCtrlCreateButton("...", 370, 110, 20, 20)
GuiCtrlSetOnEvent($x, "BottomPickFile")

$x = GuiCtrlCreateButton("Encrypt / Decrypt", 100, 140, 200)
GuiCtrlSetOnEvent($x, "EncryptDecrypt")

$Output = GuiCtrlCreateEdit("", 10, 170, 380, 100, BitOR($GUI_SS_DEFAULT_EDIT, $ES_READONLY))

GuiCtrlSetState($Pass, $GUI_FOCUS)

GUISetState(@SW_SHOW)

While 1
  Sleep(1000)  ; Idle around
WEnd

Func CLOSEClicked()
  Exit
EndFunc

func AboutHelp()
	MsgBox(64, "About BURP-GUI " & $BurpGuiVersion, _
	    "BURP-GUI was written in AutoIt3 (a nice scripting language) and merely executes the command-line " & @CRLF & _
		"version of BURP.  Both BURP and BURP-GUI are placed in the public domain, with complete source " & @CRLF & _
		"code available.")
endfunc

func PassHelp()
	MsgBox(64, "Passphrase and Key Help", _
		"One should choose a passphrase or a key very carefully.  A key is a 1 to 16 character " & _
		"string that should contain completely random characters.  Good examples are:" & @CRLF & _
		@CRLF & _
		chr(9) & "&yRw#5.Mw)3=gX3q" & @CRLF & _
		chr(9) & "j6dfZHJGFhyu7Rz8" & @CRLF & _
		@CRLF & _
		"A passphrase is a longer set of words and symbols that are easier to remember, but can " & _
		"provide the same amount of security.  It must have from 32 to 256 characters. " & _
		"This is one sample passphrase:" & @CRLF & _
		@CRLF & _
		chr(9) & "duobus.modis.fit.iniuria.1.by.forca.2.by.frauda" & @CRLF & _
		@CRLF & _
		"CaPiTaLiZaTiOn matters!")
endfunc

func WarningsHelp()
	MsgBox(64, "Security-Related Warnings", _
	    "There are a few things you should know about before you use this program:" & @CRLF & _
		@CRLF & _
		" - Your password could be cached in the pagefile if your computer is low on available memory." & @CRLF & _
		" - Since this runs an external file, the password could be cached someplace by the system." & @CRLF & _
		" - BURP does not add a header to the encoded file, so if you use the wrong password, it will " & _
		"decode to garbage with no warning.")
endfunc
	
func BurpWebsite()
	OpenWebPage("http://www.geodyssey.com/cryptography/cryptography.html")
EndFunc

func BurpGuiWebsite()
	OpenWebPage("http://rumkin.com/software/burp/")
EndFunc

func OpenWebPage($url)
	DllCall("shell32.dll", "long", "ShellExecute", "hwnd", 0, "string", "", "string", $url, _
		"string", "", "string", "", "long", @SW_SHOWNORMAL)
endfunc

func ShowPlainText()
	$x = GuiCtrlRead($PlainText)
	$passdata = GuiCtrlRead($Pass)
	GuiCtrlDelete($Pass)
	if BitAnd(1, $x) == 0 Then
		$Pass = GuiCtrlCreateInput("", 100, 30, 290, 20, BitOR($ES_PASSWORD, $ES_AUTOHSCROLL))
	Else
		$Pass = GuiCtrlCreateInput("", 100, 30, 290, 20)
	endif
	GuiCtrlSetData($Pass, $passdata)
	GuiCtrlSetState($Pass, $GUI_FOCUS)
EndFunc

func ToggleLabels()
	$e = BitAND(GuiCtrlRead($Encrypt), 1)
	if $e <> $EncryptLast then
		$EncryptLast = $e
		$c = GuiCtrlRead($TopLabel)
		GuiCtrlSetData($TopLabel, GuiCtrlRead($BottomLabel))
		GuiCtrlSetData($BottomLabel, $c)
	endif
EndFunc

func TopPickFile()
	$fn = FileOpenDialog("Select File", @DesktopDir, "All (*.*)", 1 + 2)
	if @error == 0 and $fn <> "" then
		GuiCtrlSetData($TopFile, $fn)
	endif
EndFunc

func BottomPickFile()
	$fn = FileSaveDialog("Select File", @DesktopDir, "All (*.*)", 2 + 16)
	if @error == 0 and $fn <> "" then
		GuiCtrlSetData($BottomFile, $fn)
	endif
endfunc

func EncryptDecrypt()
	$cmd = "burp32.exe "
	$pw = GuiCtrlRead($Pass)
	if StringLen($pw) < 8 or (StringLen($pw) > 16 and StringLen($pw) < 32) then
		GuiCtrlSetData($Output, "You need to specify a passphrase (32-256 characters)" & @CRLF & _
			"or a key (1-16 characters).")
	endif
	if StringLen($pw) <= 16 then
		$cmd = $cmd & "-k=""" & $pw & """ "
	Else
		$cmd = $cmd & "-p=""" & $pw & """ "
	endif
	if BitAnd(1, GuiCtrlRead($Encrypt)) == 1 Then
		$cmd = $cmd & "-e "
	Else
		$cmd = $cmd & "-d "
	endif
	$cmd = $cmd & """" & GuiCtrlRead($TopFile) & """ """ & GuiCtrlRead($BottomFile) & """"
	
	GuiCtrlSetData($Output, $cmd)
	if FileInstall("burp32.exe", @TempDir & "\__burp32.exe", 1) == 0 Then
		MsgBox(16, "Can Not Copy File", "Unable to copy burp32.exe to Windows temp directory" & @CRLF & _
			@TempDir)
		MsgBox(16, "asdf", @TempDir & "\__burp32.exe")
		Return
	endif
	$WD = @WorkingDir
	FileChangeDir(@TempDir)
	$cmd = @ComSpec & " /c __" & $cmd & " > burp_out.txt"
	ConsoleWrite($cmd & @CR)
	$ret = RunWait($cmd, "", @SW_HIDE)
	FileDelete("__burp32.exe")
	
	$contents = FileRead("burp_out.txt", FileGetSize("burp_out.txt"))
	FileDelete("burp_out.txt")
	FileChangeDir($WD)
	if StringLen($contents) > 0 then
		GuiCtrlSetData($Output, GuiCtrlRead($Output) & @CRLF & $contents)
	EndIf
	
	if $ret == 0 Then
		GuiCtrlSetData($Output, GuiCtrlRead($Output) & @CRLF & @CRLF & "Successful.")
	Else
		GuiCtrlSetData($Output, GuiCtrlRead($Output) & @CRLF & @CRLF & "Error code " & $ret)
	endif
EndFunc
